#include <stdio.h>

void  initMatrix(double *A, int n, int m, double c) {
  int i,j;
  for (i=0; i<n; i++)
    for (j=0; j<m; j++)
      A[i*m+j] = c + i -j;
}

void  printMatrix(double *A, int n, int m) {
  int i,j;
  for (j=0; j<m; j++)
    for (i=0; i<n; i++)
      printf("%d  %d  %lf \n",i,j,A[i*m+j]);
}

int main(int argc, char *argv[]) {
  int i, j, i_h, j_h; 
  const int N = 5, M = 5, N_halo = 2;
  double A[N][M], C[N][M];

  initMatrix((double *) A, N, M, 1.0);
  initMatrix((double *) C, N, M, 7.0);

  // C = A + B
  for (i=N_halo; i<N-N_halo; i++)
    for (j=N_halo; j<M-N_halo; j++) {
        C[i][j] = 0.;
        for (i_h=-N_halo; i_h<N_halo+1; i_h++)
            for (j_h=-N_halo; j_h<N_halo+1; j_h++) 
                C[i][j] = C[i][j] + A[i+i_h][j+j_h] ;
        C[i][j] = C[i][j] / ((2*N_halo+1)*(2*N_halo+1)) ;
    }

//  printf("%f %f %f\n", C[5][4], C[1][1], C[N-1][M-1]);
  printMatrix((double *) C, N, M);

  return 0;
}
